//+------------------------------------------------------------------+
//|     Mathemat                              |
//| http://forum.mql4.com/ru/10446/page29                            |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 PaleVioletRed
#property indicator_width1 2

//
//
//
//
//

extern int QrmaPeriod = 20;
extern int Price      =  0; 

//
//
//
//
//

double qrma[];
double cena[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,qrma);
      SetIndexBuffer(1,cena);
   
         Price      = MathMax(MathMin(Price,6),0);
         QrmaPeriod = MathMax(QrmaPeriod,1);

   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,counted_bars=IndicatorCounted();

   if(QrmaPeriod>=Bars) return( 0);
   if(counted_bars<0)   return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   double qwmaCoeff = (10.0-15.0/(QrmaPeriod+2.0));
   double lwmaCoeff = (12.0-15.0/(QrmaPeriod+2.0));
   double qwmwCoeff = 6.0/(QrmaPeriod*(QrmaPeriod+1.0)*(2.0*QrmaPeriod+1.0));
   for(int i=limit; i>=0; i--)
   {
      cena[i]=iMA(NULL,0,1,0,MODE_SMA,Price,i);
            double sump = 0;  for (int j=0; j<QrmaPeriod && (i+j)<Bars; j++) sump += cena[i+j]*(QrmaPeriod-j)*(QrmaPeriod-j);
            double qwma = sump*qwmwCoeff;
      qrma[i] = 3.0*iMA(NULL,0,QrmaPeriod,0,MODE_SMA,Price,i) + qwma*qwmaCoeff - iMA(NULL,0,QrmaPeriod,0,MODE_LWMA,Price,i)*lwmaCoeff;
   }
   return(0);
}